close all; clear all; clc;
load analyze.mat


%% Spectrum


separation=-10;

figure
hold on



figure(9) 
hold on
Spectrum=amp(6,:).*exp(lamb(6,:)*separation);
errorbar(48:7:118,Spectrum,Spectrum.*sqrt((Ierrp(6,:,1)./amp(6,:)).^2+(separation*Ierrp(6,:,2)).^2),'k','linewidth',2)
 
%  plot(48:7:118, SP_spec_1(1:2:(end-1))*5e+16,'k','linewidth',2)
load('GFW/Spec3.mat')
 plot(48:7:118, Spectr(1:11)./max(Spectr(1:11))*max(Spectrum),'--or','linewidth',2)
load('GFW/Spec5.mat')
 plot(48:7:118, Spectr(1:11)./max(Spectr(1:11))*max(Spectrum),'-^r','linewidth',2)
load('GFW/Spec7.mat')
 plot(48:7:118, Spectr(1:11)./max(Spectr(1:11))*max(Spectrum),'-.*r','linewidth',2)

set(gca,'fontsize',16)

legend('Data','3ps','5ps','7ps','location','northeast')
xlabel('Angle, [deg.]')
ylabel('Amplitude, [a.u.]')
title('Spectrum')
grid on 
% ylim([0 0.02])
% load('GFW/SEY.mat')


figure(10) 
  [hc hc]=contourf (48:7:118, Bphase, amp.*exp(lamb.*separation))
    set(hc,'LineStyle','none');

 set(gca,'fontsize',16)
 xlabel('Angle, [deg.]')
 ylabel('\phi_B, [a.u.]')
 title('Spectrum map')
 
 
 load('GFW/SEY5c.mat')

figure(10341) 
 [hc hc]=contourf(300./(6*(1-cos((48:7:118)/180*pi))), Bphase, amp.*exp(lamb.*(-5))./repmat((Integral(1:11)),[7 1])*1e-17,40)
 colorbar
  set(hc,'LineStyle','none');
 set(gca,'fontsize',16)
 xlabel('Frequency, [GHz]')
 ylabel('\phi_B, [a.u.]')
 title('Form Factor (BGS=5 mm)')


load('GFW/SEY10c.mat')

 figure(10342) 
 [hc hc]=contourf(300./(6*(1-cos((48:7:118)/180*pi))), Bphase, amp.*exp(lamb.*(-10))./repmat((Integral(1:11)),[7 1])*1e-17,40)
 colorbar
  set(hc,'LineStyle','none');
 set(gca,'fontsize',16)
 xlabel('Frequency, [GHz]')
 ylabel('\phi_B, [a.u.]')
 title('Form Factor (BGS=10 mm)')
 
 
load('GFW/SEY15c.mat')

 figure(10343) 
 [hc hc]=contourf(300./(6*(1-cos((48:7:118)/180*pi))), Bphase, amp.*exp(lamb.*(-15))./repmat((Integral(1:11)),[7 1])*1e-17,40)
 colorbar
  set(hc,'LineStyle','none');
 set(gca,'fontsize',16)
 xlabel('Frequency, [GHz]')
 ylabel('\phi_B, [a.u.]')
 title('Form Factor (BGS=15 mm)')
%  
% figure(11) 
% [hc hc]=contourf(300./(6*(1-cos((48:7:118)/180*pi))), Bphase, amp.*exp(lamb.*separation),40)
% 
%  colorbar
%   set(hc,'LineStyle','none');
%  set(gca,'fontsize',16)
%  xlabel('Frequency, [GHz]')
%  ylabel('\phi_B, [a.u.]')
%  title('Spectrum without background')
% 
%  

figure(12) 
c=6;
hold on
load('GFW/SEY5c.mat')
plot(300./(6*(1-cos((48:7:118)/180*pi))), ((amp(c,:).*exp(lamb(c,:)*separation))./Integral(1:11)*1e-25),'-^k','linewidth',2)
load('GFW/SEY10c.mat')
plot(300./(6*(1-cos((48:7:118)/180*pi))), ((amp(c,:).*exp(lamb(c,:)*separation))./Integral(1:11)*1e-25),'-^r','linewidth',2)
load('GFW/SEY15c.mat')
plot(300./(6*(1-cos((48:7:118)/180*pi))), ((amp(c,:).*exp(lamb(c,:)*separation))./Integral(1:11)*1e-25),'-^b','linewidth',2)
set(gca,'fontsize',16)
legend('BGS=5mm','BGS=10mm','BGS=15mm','Location','northwest')
xlabel('Frequency, [GHz]')
ylabel('Amplitude, [a.u.]')
title('FormFactor')
grid on

load('GFW/SEY10c.mat')
figure
hold on
plot(300./(6*(1-cos((48:7:118)/180*pi))),  amp(1,:).*exp(lamb(1,:).*(-10))./(Integral(1:11))*1e-24,'-^b','linewidth',2)
plot(300./(6*(1-cos((48:7:118)/180*pi))),  amp(3,:).*exp(lamb(3,:).*(-10))./(Integral(1:11))*1e-24,'-^m','linewidth',2)
plot(300./(6*(1-cos((48:7:118)/180*pi))),  amp(4,:).*exp(lamb(4,:).*(-10))./(Integral(1:11))*1e-24,'-^k','linewidth',2)
 plot(300./(6*(1-cos((48:7:118)/180*pi))),  amp(5,:).*exp(lamb(5,:).*(-10))./(Integral(1:11))*1e-24,'-^g','linewidth',2)
plot(300./(6*(1-cos((48:7:118)/180*pi))),  amp(7,:).*exp(lamb(7,:).*(-10))./(Integral(1:11))*1e-24,'-^r','linewidth',2)

 set(gca,'fontsize',16)
 xlabel('Frequency, [GHz]')
 legend('\phi_B=5.84','\phi_B=5.64','\phi_B=5.54','\phi_B=5.44','\phi_B=6.04')
 title('Form Factor (BGS=10 mm)')
ylabel('Amplitude, [a.u.]')
grid on
Freq=300./(3*(1-cos((48:7:118)/180*pi)));
for c=1:7
FF(c,:)=amp(c,:).*exp(lamb(c,:).*(-10))./(Integral(1:11))*1e-24;
end
save FFX.mat Freq FF
