clear all; close all
phi=-10:0.1:10;%azimutal angle deg
 dthet=-10:0.1:10;%polar angle deg, (shift from optic axis of the mirror)

 for Thet=48:7:125



for c=1:length(dthet)
Lamb=3*(1-cos((Thet+dthet(c))/180*pi));
R=Lamb/2;%focal spot (Abbe diffraction limit)
r=1;%detector radius
d=50.8*sqrt(tan(phi/180*pi).^2+tan(dthet(c)/180*pi).^2);
A=@(x,y)x^2*acos(y./x)-y.*sqrt(x^2-y.^2);
d1=(d.^2-r^2+R^2)./(2*d);
d2=d-d1;
Cs=A(R,d1)+A(r,d2);%sum of two lengthes

Map(c,:)=real(Cs);
end 
figure
contourf(dthet,phi,Map')
xlabel('\Theta')
ylabel('\phi')
title(num2str(Thet))
 save(['map' num2str(Thet) '.mat'],'Map')
end