close all; clear all; clc
load FFX.mat
cd('./KK')

for c=[1:7]%, 14:18
    c
% for c=1:20
% SP=flip(Freq([3:4, 6:end-1]));
% SS(c,:)=flip(FF(c,[3:4, 6:end-1]))/9/5/3;
 SP=flip(Freq([3:end-1]));
 SS(c,:)=flip(FF(c,[3:end-1]))/9/5/3;
% SSM(c)=max(SS);
[RSP,ISP(c,:)]=SRf(SP,SS(c,:));
% 

% figure (1)
% plot(SP,SS(c,:),'or')
% hold on
%  plot(RSP)

 PhaseH=-(imag(hilbert(log(abs(RSP)))));
RPH=real((ifft(RSP.*exp(1i.*(PhaseH)))));


% figure(2)
[mx,ps]=max(RPH)
 RPH= [zeros(1,230-ps), RPH(1:end-(230-ps))]
%  plot((1:length(RPH))*1e-9/length(RPH),RPH)

Gauss=@(mu,sig,A,x)A.*exp(-(x-mu).^2/(2*sig^2))
% hold on
%2.1e-12
Profile5=Gauss(ps*1e-9/length(RPH),2.1e-12,mx,(1:length(RPH))*1e-9/length(RPH));
% plot((1:length(RPH))*1e-9/length(RPH),Profile5,'r')
 FWHM(c)=sum(RPH>max(RPH)/2)*1e-9/length(RPH)
  FW01M(c)=sum(RPH>max(RPH)*0.1)*1e-9/length(RPH)
 FW09M(c)=sum(RPH>max(RPH)*0.9)*1e-9/length(RPH)

 
PR(c,:)=RPH;
sum(Profile5>max(Profile5)/2)*1e-9/length(Profile5)
% figure(1)
% plot(abs(fft(RPH)),'r')
% plot(abs(fft(Profile5./sum(Profile5))),'k')

 end
Bphase=sort([5.84 5.74 5.64 5.54 5.44 5.94 6.04]);

% ds=1:20;
 figure
 hold on
plot(Bphase,FW01M(:)*1e+12,'->k','linewidth',2)
plot(Bphase,FWHM(:)*1e+12,'->b','linewidth',2)
plot(Bphase,FW09M(:)*1e+12,'->r','linewidth',2)

 set(gca,'fontsize',16)
  xlabel('\phi_B, [a.u.]')
 ylabel('Pulsewidth, [ps]')
 legend('FW0.1M','FWHM','FW0.9M','Orientation','horizontal')
 grid on
 title('Pulsewidth vs. Buncher phase')
 
figure
[hc hc]=contourf((1:length(RPH))*1e-9/length(RPH)*1e+12,Bphase,PR*500)
colorbar
  set(hc,'LineStyle','none');
xlim([10 50])
 set(gca,'fontsize',16)

 xlabel('Time, [ps]')
 ylabel('\phi_B, [a.u.]')
 title('Bunch profile')
 
 
 figure
 
 hold on
plot(SP,  SS(2,:),'ob','linewidth',2)
plot(0:(length(ISP)-1),  ISP(2,:),'-.b','linewidth',2)
plot(SP,  SS(4,:),'om','linewidth',2)
plot(0:(length(ISP)-1),  ISP(4,:),'-.m','linewidth',2)
plot(SP,  SS(6,:),'ok','linewidth',2)
plot(0:(length(ISP)-1),  ISP(6,:),'-.k','linewidth',2)
plot(SP,  SS(1,:),'og','linewidth',2)
plot(0:(length(ISP)-1),  ISP(1,:),'-.g','linewidth',2)
plot(SP,  SS(3,:),'or','linewidth',2)
plot(0:(length(ISP)-1),  ISP(3,:),'-.r','linewidth',2)

 set(gca,'fontsize',16)
 xlabel('Frequency, [GHz]')
 legend('\phi_B=5.84','\phi_B=5.74','\phi_B=5.54','\phi_B=5.44','\phi_B=6.04')
 % 2 4 6 8 10
 title('Form Factor (BGS=10 mm)')
ylabel('Amplitude, [a.u.]')
xlim([0, 300])
grid on
 
  figure
 
 hold on
plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(1,:)*500,'-.b','linewidth',2)
plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(3,:)*500,'-.m','linewidth',2)
plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(5,:)*500,'-.k','linewidth',2)
plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(2,:)*500,'-.g','linewidth',2)
plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(7,:)*500,'-.r','linewidth',2)

 set(gca,'fontsize',16)
 xlabel('Time, [ps]')
 legend('\phi_B=5.84','\phi_B=5.64','\phi_B=5.44','\phi_B=5.74','\phi_B=6.04')
 % 2 4 6 8 10
 title('Reconstructed profile')
ylabel('Amplitude, [a.u.]')
xlim([0, 50])
grid on
 
%   
%   figure
%  
%  hold on
% plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(5,:)*500,'-.b','linewidth',2)
% plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(6,:)*500,'-.m','linewidth',2)
% plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(7,:)*500,'-.k','linewidth',2)
% plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(2,:)*500,'-.g','linewidth',2)
% plot((0:(length(RPH)-1))*1e-9/length(RPH)*1e+12,  PR(1,:)*500,'-.r','linewidth',2)
% 
%  set(gca,'fontsize',16)
%  xlabel('Time, [ps]')
%  legend('\phi_B=8.14','\phi_B=8.19','\phi_B=8.24','\phi_B=5.54','\phi_B=5.44')
%  % 2 4 6 8 10
%  title('Reconstructed profile')
% ylabel('Amplitude, [a.u.]')
% xlim([0, 50])
% grid on
%  
%  Bphase=sort([5.84 5.74 5.64 5.54 5.44 5.94 6.04]);
% 
%  time =(0:(length(RPH)-1))*1e-9/length(RPH)*1e+9;%ns
%  Profile=PR(6,:)*500;
%  
% %  save P6.mat time Profile
 
 
 
 
 
 
 
 
 
 
 
 
 
 cd('..')
